use serde_derive::Deserialize;

#[derive(Debug, Clone, Deserialize)]
pub struct ServerConfig {
    pub host: String,
    pub port: u16,
    pub nginx_sendfile: bool,
}

#[derive(Debug, Clone, Deserialize)]
pub struct DatabaseConfig {
    pub sql_backend: String,
    pub url: String,
}

#[derive(Debug, Clone, Deserialize)]
pub struct LoggingConfig {
    pub level: String,
    pub metrics: bool,
}

#[derive(Debug, Clone, Deserialize)]
pub struct OperationsConfig {
    pub filename_size: u8,
    pub adminkey_size: u8,
    pub apikey_size: u8,
    pub engine_mode: i64,
    pub cleaner_interval: i32,
    pub file_expiry_min: u32,
    pub file_expiry_max: u32,
    pub max_filesize: u64,
    pub banned_mimetype: Vec<String>,
    pub unsafe_mimetype: Vec<String>,
}

#[derive(Debug, Clone, Deserialize)]
pub struct AppConfig {
    pub server: ServerConfig,
    pub database: DatabaseConfig,
    pub logging: LoggingConfig,
    pub operations: OperationsConfig,
}
